/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : SCI1.c
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : Init_SCI
**     Version     : Component 01.094, Driver 01.22, CPU db: 3.50.001
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2013-03-12, 11:39, # CodeGen: 4
**     Abstract    :
**         This "Init_SCI" Peripheral Inspector implements the
**         Serial Communications Interface module (SCI), basic
**         initialization and settings.
**     Settings    :
**         Serial channel              : QSCI0
**
**         Communication setting
**             Divisor value           : 651
**             Init baud rate          : 19201.228879 Bd
**             Data format             : 8 bits
**             Wakeup                  : by idle line
**             Polarity                : normal
**             Parity                  : none
**             SCI run in Wait mode    : Enabled
**
**         Interrupts
**           Receiver Full             : Enabled
**             ISR name                : fisr_sci_rx_full
**             Interrupt name          : INT_QSCI0_RCV
**             Priority                : fast interrupt 1
**
**           Receiver Error            : Enabled
**             ISR name                : fisr_sci_rx_full
**             Interrupt name          : INT_QSCI0_RERR
**             Priority                : fast interrupt 0
**
**           Transmitter Complete      : Disabled
**
**           Transmitter Ready         : Disabled
**
**     Contents    :
**         Init - void SCI1_Init(void);
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE SCI1. */

#include "SCI1.h"

/*
** ###################################################################
**
**  The following method(s) must be implemented by the user in one
**  of the following modules:
**
**    #if defined(fisr_sci_rx_full_FAST_INT)
**    #pragma interrupt fast
**    #elif defined(fisr_sci_rx_full_VECT_TABLE_ISR_FAST_INT)
**    #pragma define_section interrupt_fast "interrupt_fast.text"  RX
**    #pragma section interrupt_fast begin
**    #pragma interrupt fast
**    #else
**    #pragma interrupt
**    #endif
**    void fisr_sci_rx_full(void)
**    {
**      // Your interrupt code
**    }
**    #if defined(fisr_sci_rx_full_VECT_TABLE_ISR_FAST_INT)
**    #pragma section interrupt_fast end
**    #endif
**
**  Modules:
**       ProcessorExpert
**       Events
**
** ###################################################################
*/

/*
** ===================================================================
**     Method      :  SCI1_Init (component Init_SCI)
**
**     Description :
**         This method initializes registers of the SCI module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see "Call Init method" property of the
**         bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void SCI1_Init(void)
{
  getReg(QSCI0_STAT);                  /* Clear interrupt request flags */
  /* QSCI0_RATE: SBR=0x028B,FRAC_SBR=0 */
  setReg16(QSCI0_RATE, 0x1458U);       /* Set prescaler bits */ 
  /* QSCI0_CTRL1: LOOP=0,SWAI=0,RSRC=0,M=0,WAKE=0,POL=0,PE=0,PT=0,TEIE=0,TIIE=0,RFIE=1,REIE=1,TE=1,RE=1,RWU=0,SBK=0 */
  setReg16(QSCI0_CTRL1, 0x3CU);        /* Set the SCI control register */ 
  /* QSCI0_CTRL2: TFCNT=0,TFWM=0,RFCNT=0,RFWM=0,FIFO_EN=0,RIEIE=0,LINMODE=0,RIIE=0,TDE=0,RDE=0 */
  setReg16(QSCI0_CTRL2, 0x00U);        /* Set the SCI control register */ 
  /* QSCI0_CTRL3: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,SHEN=0 */
  setReg16(QSCI0_CTRL3, 0x00U);        /* Set the SCI control 3 register */ 
}

/* END SCI1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
