/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : SCI1.h
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : Init_SCI
**     Version     : Component 01.094, Driver 01.22, CPU db: 3.50.001
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2013-03-11, 21:47, # CodeGen: 1
**     Abstract    :
**         This "Init_SCI" Peripheral Inspector implements the
**         Serial Communications Interface module (SCI), basic
**         initialization and settings.
**     Settings    :
**         Serial channel              : QSCI0
**
**         Communication setting
**             Divisor value           : 651
**             Init baud rate          : 19201.228879 Bd
**             Data format             : 8 bits
**             Wakeup                  : by idle line
**             Polarity                : normal
**             Parity                  : none
**             SCI run in Wait mode    : Enabled
**
**         Interrupts
**           Receiver Full             : Enabled
**             ISR name                : fisr_sci_rx_full
**             Interrupt name          : INT_QSCI0_RCV
**             Priority                : fast interrupt 1
**
**           Receiver Error            : Enabled
**             ISR name                : fisr_sci_rx_full
**             Interrupt name          : INT_QSCI0_RERR
**             Priority                : fast interrupt 0
**
**           Transmitter Complete      : Disabled
**
**           Transmitter Ready         : Disabled
**
**     Contents    :
**         Init - void SCI1_Init(void);
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __SCI1
#define __SCI1

/* MODULE SCI1. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "Cpu.h"

/* PESL device mapping  */
#define SCI1_DEVICE QSCI0

void fisr_sci_rx_full(void);

#define fisr_sci_rx_full_FAST_INT
/*
** ===================================================================
** The interrupt service routine must be implemented by user in one
** of the user modules (see SCI1.c file for more information).
** ===================================================================
*/

void fisr_sci_rx_full(void);

#define fisr_sci_rx_full_FAST_INT
/*
** ===================================================================
** The interrupt service routine must be implemented by user in one
** of the user modules (see SCI1.c file for more information).
** ===================================================================
*/



#define fisr_sci_rx_full_FAST_INT


void SCI1_Init(void);
/*
** ===================================================================
**     Method      :  SCI1_Init (component Init_SCI)
**
**     Description :
**         This method initializes registers of the SCI module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see "Call Init method" property of the
**         bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

/* END SCI1. */

#endif /* ifndef __SCI1 */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
